diff -Nurp '--exclude=.bzr*' tin-2.6.4/include/extern.h tin-2.6.5/include/extern.h
--- tin-2.6.4/include/extern.h	2024-12-21 15:09:49.000000000 +0100
+++ tin-2.6.5/include/extern.h	2025-12-16 18:58:17.756313703 +0100
@@ -1830,7 +1897,7 @@ extern int xcol;
 extern int xmouse;
 extern int xrow;
 
-extern unsigned short debug;
+extern unsigned int debug;
 
 extern t_artnum *base;
 
@@ -1840,6 +1907,10 @@ extern size_t tabwidth;
 
 extern pid_t process_id;
 
+#ifdef NNTPS_ABLE
+	extern time_t startup_time;
+#endif /* NNTPS_ABLE */
+
 #ifdef USE_HEAPSORT
 	extern int tin_sort(void *, size_t, size_t, t_compfunc);
 	extern constext *txt_sort_functions[];
@@ -1850,12 +1921,19 @@ extern struct regex_cache strip_re_regex
 extern struct regex_cache strip_was_regex;
 extern struct regex_cache uubegin_regex;
 extern struct regex_cache uubody_regex;
+extern struct regex_cache xxbody_regex;
 extern struct regex_cache verbatim_begin_regex;
 extern struct regex_cache verbatim_end_regex;
+extern struct regex_cache hideline_regex;
+extern struct regex_cache yencbegin_regex;
+extern struct regex_cache yencpart_regex;
+extern struct regex_cache yencend_regex;
 extern struct regex_cache url_regex;
 extern struct regex_cache mail_regex;
 extern struct regex_cache news_regex;
 extern struct regex_cache shar_regex;
+extern struct regex_cache shar_end_regex;
+extern struct regex_cache latex_regex;
 extern struct regex_cache slashes_regex;
 extern struct regex_cache stars_regex;
 extern struct regex_cache underscores_regex;
@@ -1878,6 +1956,7 @@ extern struct t_newnews *newnews;
 extern struct t_option option_table[];
 extern struct t_save *save;
 extern struct t_capabilities nntp_caps;
+extern struct t_serverrc serverrc;
 
 extern t_bool *OPT_ON_OFF_list[];
 extern t_bool can_post;
@@ -1959,7 +2038,8 @@ enum {
 extern int hist_last[HIST_MAXNUM + 1];
 extern int hist_pos[HIST_MAXNUM + 1];
 extern char *input_history[HIST_MAXNUM + 1][HIST_SIZE + 1];
-extern long motd_hash;
+
+extern volatile sig_atomic_t pending_sactions;
 
 /* defines for GNKSA checking */
 /* success/undefined failure */
@@ -2033,7 +2113,7 @@ extern t_bool word_highlight;
 #ifdef HAVE_FASCIST_NEWSADMIN
 	extern constext txt_error_followup_to_several_groups[];
 	extern constext txt_error_grp_renamed[];
-	extern constext txt_error_missing_followup_to[];
+	extern constext *txt_error_missing_followup_to_sp[];
 	extern constext txt_error_not_valid_newsgroup[];
 #endif /* HAVE_FASCIST_NEWSADMIN */
 
@@ -2044,7 +2124,7 @@ extern t_bool word_highlight;
 #endif /* !ALLOW_FWS_IN_NEWSGROUPLIST */
 
 #ifdef HAVE_PGP_GPG
-	extern constext txt_pgp_add[];
+	extern constext *txt_pgp_add_sp[];
 	extern constext txt_pgp_mail[];
 	extern constext txt_pgp_news[];
 	extern constext txt_pgp_not_avail[];
@@ -2117,9 +2197,9 @@ extern struct opttxt txt_catchup_read_gr
 #else
 	extern struct opttxt txt_highlight_options;
 #endif /* HAVE_COLOR */
-#if defined(USE_ZLIB) && defined(CPP_DOES_CONCAT)
+#ifdef USE_ZLIB
 	extern struct opttxt txt_compress_overview_files;
-#endif /* USE_ZLIB && CPP_DOES_CONCAT */
+#endif /* USE_ZLIB */
 extern struct opttxt txt_confirm_choice;
 extern struct opttxt txt_date_format;
 extern struct opttxt txt_display_options;
@@ -2138,7 +2218,7 @@ extern struct opttxt txt_getart_limit_op
 extern struct opttxt txt_goto_next_unread;
 extern struct opttxt txt_group_catchup_on_exit;
 extern struct opttxt txt_group_format;
-extern struct opttxt txt_hide_uue;
+extern struct opttxt txt_hide_inline_data;
 extern struct opttxt txt_inews_prog;
 extern struct opttxt txt_interactive_mailer;
 extern struct opttxt txt_inverse_okay;
@@ -2146,6 +2226,7 @@ extern struct opttxt txt_inverse_okay;
 	extern struct opttxt txt_ispell;
 #endif /* HAVE_ISPELL */
 extern struct opttxt txt_keep_dead_articles;
+extern struct opttxt txt_keep_expired_filters;
 extern struct opttxt txt_kill_level;
 extern struct opttxt txt_mail_8bit_header;
 extern struct opttxt txt_mail_address;
@@ -2180,6 +2261,7 @@ extern struct opttxt txt_news_quote_form
 extern struct opttxt txt_organization;
 extern struct opttxt txt_page_mime_format;
 extern struct opttxt txt_page_uue_format;
+extern struct opttxt txt_page_yenc_format;
 extern struct opttxt txt_pos_first_unread;
 extern struct opttxt txt_post_8bit_header;
 extern struct opttxt txt_post_mime_encoding;
@@ -2208,12 +2290,25 @@ extern struct opttxt txt_reread_active_f
 extern struct opttxt txt_savedir;
 extern struct opttxt txt_savefile;
 extern struct opttxt txt_saving_options;
+extern struct opttxt txt_scope_marked_global;
+extern struct opttxt txt_scope_marked_global_match;
+extern struct opttxt txt_scope_marked_local;
+extern struct opttxt txt_scope_marked_local_match;
 extern struct opttxt txt_score_limit_kill;
 extern struct opttxt txt_score_limit_select;
 extern struct opttxt txt_score_kill;
 extern struct opttxt txt_score_select;
 extern struct opttxt txt_scroll_lines;
 extern struct opttxt txt_select_format;
+extern struct opttxt txt_serverrc_add_cmd_line_opts;
+extern struct opttxt txt_serverrc_cache_overview_files;
+#ifdef USE_ZLIB
+	extern struct opttxt txt_serverrc_compress_overview_files;
+#endif /* USE_ZLIB */
+extern struct opttxt txt_serverrc_config_options;
+extern struct opttxt txt_serverrc_disabled_nntp_cmds;
+extern struct opttxt txt_serverrc_nntp_pipeline_limit;
+extern struct opttxt txt_serverrc_tinrc_override_options;
 extern struct opttxt txt_show_author;
 extern struct opttxt txt_show_description;
 extern struct opttxt txt_show_help_mail_sign;
@@ -2261,6 +2356,7 @@ extern struct opttxt txt_use_mouse;
 extern struct opttxt txt_verbatim_begin_regex;
 extern struct opttxt txt_verbatim_end_regex;
 extern struct opttxt txt_verbatim_handling;
+extern struct opttxt txt_hideline_regex;
 extern struct opttxt txt_wildcard;
 extern struct opttxt txt_word_highlight;
 extern struct opttxt txt_word_h_display_marks;
diff -Nurp '--exclude=.bzr*' tin-2.6.4/include/keymap.h tin-2.6.5/include/keymap.h
--- tin-2.6.4/include/keymap.h	2024-11-25 20:44:39.000000000 +0100
+++ tin-2.6.5/include/keymap.h	2025-11-13 02:24:12.887174323 +0100
@@ -3,10 +3,10 @@
  *  Module    : keymap.h
  *  Author    : J. Faultless, D. Nimmich
  *  Created   : 1999
- *  Updated   : 2024-11-17
+ *  Updated   : 2025-11-06
  *  Notes     :
  *
- * Copyright (c) 1999-2025 Jason Faultless <jason@altarstone.com>
+ * Copyright (c) 1999-2026 Jason Faultless <jason@altarstone.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -126,7 +126,7 @@
 /*
  * Maximum chars (including null byte) needed to print a key name
  * A multibyte character can use up to MB_CUR_MAX chars. But as MB_CUR_MAX
- * can't be used here, use MB_LEN_MAX instead.
+ * can't be used here (avoid VLAs), use MB_LEN_MAX instead.
  * Some values for MB_LEN_MAX:
  * - glibc 2.3.5: 16
  * - gcc 4.0: 1
@@ -170,6 +170,7 @@ enum defined_functions {
 	CONFIG_RESET_ATTRIB,
 	CONFIG_SCOPE_MENU,
 	CONFIG_SELECT,
+	CONFIG_SERVERRC_MENU,
 	CONFIG_NO_SAVE,
 	CONFIG_TOGGLE_ATTRIB,
 	FEED_ARTICLE,
@@ -235,6 +236,7 @@ enum defined_functions {
 	GROUP_GOTO,
 	GROUP_LIST_THREAD,
 	GROUP_MAIL,
+	MARK_ANCIENT_ART_READ,
 	GROUP_MARK_THREAD_READ,
 	GROUP_MARK_UNSELECTED_ARTICLES_READ,
 	GROUP_NEXT_GROUP,
@@ -294,11 +296,12 @@ enum defined_functions {
 	PAGE_TAG,
 	PAGE_TOGGLE_HEADERS,
 	PAGE_TOGGLE_HIGHLIGHTING,
+	PAGE_TOGGLE_INLINE_DATA,
 	PAGE_TOGGLE_RAW,
 	PAGE_TOGGLE_ROT13,
 	PAGE_TOGGLE_TABS,
 	PAGE_TOGGLE_TEX2ISO,
-	PAGE_TOGGLE_UUE,
+	PAGE_TOGGLE_VERBATIM,
 	PAGE_TOP_THREAD,
 	PAGE_VIEW_ATTACHMENTS,
 	PAGE_VIEW_URL,
@@ -373,7 +376,8 @@ enum defined_functions {
 	THREAD_TOGGLE_SUBJECT_DISPLAY,
 	THREAD_UNDO_SELECTIONS,
 	THREAD_UNTAG,
-	URL_SELECT
+	URL_SELECT,
+	FUNC_MAX
 };
 typedef enum defined_functions t_function;
 
@@ -443,8 +447,8 @@ extern t_function prompt_slk_response(t_
 #define PrintFuncKey(buf, func, keys) printascii(buf, (wint_t) func_to_key(func, keys))
 #else
 	extern char *printascii(char *buf, int ch);
-	extern char func_to_key (t_function func, const struct keylist keys);
-	extern t_function key_to_func (const char key, const struct keylist keys);
+	extern char func_to_key(t_function func, const struct keylist keys);
+	extern t_function key_to_func(const char key, const struct keylist keys);
 #define PrintFuncKey(buf, func, keys) printascii(buf, (int) func_to_key(func, keys))
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 #endif /* !KEYMAP_H */
diff -Nurp '--exclude=.bzr*' tin-2.6.4/include/missing_fd.h tin-2.6.5/include/missing_fd.h
--- tin-2.6.4/include/missing_fd.h	2024-11-25 20:44:39.000000000 +0100
+++ tin-2.6.5/include/missing_fd.h	2025-11-13 02:24:12.891174498 +0100
@@ -6,7 +6,7 @@
  *  Updated   : 2019-03-13
  *  Notes     :
  *
- * Copyright (c) 2019-2025 Dennis Grevenstein <dennis.grevenstein@gmail.com>
+ * Copyright (c) 2019-2026 Dennis Grevenstein <dennis.grevenstein@gmail.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
diff -Nurp '--exclude=.bzr*' tin-2.6.4/include/newsrc.h tin-2.6.5/include/newsrc.h
--- tin-2.6.4/include/newsrc.h	2024-11-25 20:44:39.000000000 +0100
+++ tin-2.6.5/include/newsrc.h	2025-11-13 02:24:12.899174847 +0100
@@ -6,7 +6,7 @@
  *  Updated   : 2024-09-27
  *  Notes     : newsrc bit handling
  *
- * Copyright (c) 1997-2025 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
+ * Copyright (c) 1997-2026 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
diff -Nurp '--exclude=.bzr*' tin-2.6.4/include/nntplib.h tin-2.6.5/include/nntplib.h
--- tin-2.6.4/include/nntplib.h	2024-11-25 20:44:39.000000000 +0100
+++ tin-2.6.5/include/nntplib.h	2025-11-13 02:24:12.903175021 +0100
@@ -3,10 +3,10 @@
  *  Module    : nntplib.h
  *  Author    : I.Lea
  *  Created   : 1991-04-01
- *  Updated   : 2024-04-01
+ *  Updated   : 2025-07-29
  *  Notes     : nntp.h 1.5.11/1.6 with extensions for tin
  *
- * Copyright (c) 1991-2025 Iain Lea <iain@bricbrac.de>
+ * Copyright (c) 1991-2026 Iain Lea <iain@bricbrac.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -205,13 +205,18 @@ struct t_capabilities {
 	t_bool list_distributions:1;	/* LIST DISTRIBUTIONS, "private" extension, RFC 2980 */
 	t_bool list_moderators:1;		/* LIST MODERATORS, "private" extension */
 	t_bool list_counts:1;			/* LIST COUNTS, "private" extension */
+	t_bool listgroup:1;				/* LISTGROUP - old versions of nntpcache (< 2.3.3b1?), leafnode and SurgeNews had a buggy implementation which didn't select the group and would require an extra GROUP cmd. before */
 	t_bool xpat:1;					/* XPAT, "private" extension, RFC 2980 */
 	t_bool hdr:1;					/* HDR: "HDR", "LIST HEADERS" */
 	const char *hdr_cmd;			/* [X]HDR */
 	t_bool over:1;					/* OVER: "OVER", "LIST OVERVIEW.FMT" */
 	t_bool over_msgid:1;			/* OVER: "OVER mid" */
 	const char *over_cmd;			/* [X]OVER */
+	t_bool newgroups:1;				/* NEWGROUPS */
+#if 0
+	/* we don't do NEWNEWS */
 	t_bool newnews:1;				/* NEWNEWS */
+#endif /* 0 */
 	char *implementation;			/* IMPLEMENTATION */
 	t_bool starttls:1;				/* STARTTLS (not supported; RFC 7525 3.2, RFC 8143 2) */
 	t_bool authinfo_user:1;			/* AUTHINFO USER/PASS */
@@ -221,6 +226,7 @@ struct t_capabilities {
 	char *sasl_mech_used;			/* SASL mech in use */
 	t_bool compress:1;				/* COMPRESS */
 	enum c_algorithms compress_algorithm;	/* COMPRESS_NONE, COMPRESS_DEFLATE */
+	t_distrib_pat *distrib_pats;		/* DISTRIB.PATS linked list */
 #if defined(MAXARTNUM) && defined(USE_LONG_ARTICLE_NUMBERS)
 	t_artnum maxartnum;				/* MAXARTNUM indicating article numbers >=2^31 */
 #endif /* MAXARTNUM && USE_LONG_ARTICLE_NUMBERS */
@@ -229,7 +235,6 @@ struct t_capabilities {
 	t_bool streaming:1;				/* STREAMING: "MODE STREAM", "CHECK", "TAKETHIS" */
 	t_bool ihave:1;					/* IHAVE: "IHAVE" */
 #endif /* 0 */
-	t_bool broken_listgroup:1;		/* LISTGROUP doesn't select newsgroup */
 };
 
 #endif /* !NNTPLIB_H */
diff -Nurp '--exclude=.bzr*' tin-2.6.4/include/policy.h tin-2.6.5/include/policy.h
--- tin-2.6.4/include/policy.h	2024-11-25 20:44:39.000000000 +0100
+++ tin-2.6.5/include/policy.h	2025-11-13 02:24:12.911175370 +0100
@@ -3,10 +3,10 @@
  *  Module    : policy.h
  *  Author    : Ralf Doeblitz <doeblitz@gmx.de>
  *  Created   : 1999-01-12
- *  Updated   : 2024-11-25
+ *  Updated   : 2025-10-24
  *  Notes     : #defines and static data for policy configuration
  *
- * Copyright (c) 1999-2025 Ralf Doeblitz <doeblitz@gmx.de>
+ * Copyright (c) 1999-2026 Ralf Doeblitz <doeblitz@gmx.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -775,7 +775,6 @@ static const char *gnksa_domain_list[] =
 	"legal",
 	"lexus",
 	"lilly",
-	"lipsy",
 	"loans",
 	"locus",
 	"lotte",
@@ -903,7 +902,6 @@ static const char *gnksa_domain_list[] =
 	"design",
 	"direct",
 	"doctor",
-	"dunlop",
 	"dupont",
 	"durban",
 	"emerck",
@@ -1029,7 +1027,6 @@ static const char *gnksa_domain_list[] =
 	"auspost",
 	"banamex",
 	"bauhaus",
-	"bentley",
 	"bestbuy",
 	"booking",
 	"brother",
@@ -1204,7 +1201,6 @@ static const char *gnksa_domain_list[] =
 	"pictures",
 	"plumbing",
 	"property",
-	"redstone",
 	"reliance",
 	"saarland",
 	"samsclub",
@@ -1250,7 +1246,6 @@ static const char *gnksa_domain_list[] =
 	"institute",
 	"insurance",
 	"kuokgroup",
-	"lancaster",
 	"landrover",
 	"lifestyle",
 	"marketing",
@@ -1258,7 +1253,6 @@ static const char *gnksa_domain_list[] =
 	"melbourne",
 	"microsoft",
 	"panasonic",
-	"pramerica",
 	"richardli",
 	"shangrila",
 	"solutions",
@@ -1439,7 +1433,6 @@ static const char *gnksa_domain_list[] =
 	"xn--yfro4i67o",
 	"xn--ygbi2ammx",
 	"americanfamily",
-	"kerrylogistics",
 	"weatherchannel",
 	"xn--54b7fta0cc",
 	"xn--6qq986b3xl",
diff -Nurp '--exclude=.bzr*' tin-2.6.4/include/proto.h tin-2.6.5/include/proto.h
--- tin-2.6.4/include/proto.h	2024-12-05 04:03:46.000000000 +0100
+++ tin-2.6.5/include/proto.h	2025-12-09 04:46:58.685110758 +0100
@@ -3,10 +3,10 @@
  *  Module    : proto.h
  *  Author    : Urs Janssen <urs@tin.org>
  *  Created   :
- *  Updated   : 2024-12-05
+ *  Updated   : 2025-12-09
  *  Notes     :
  *
- * Copyright (c) 1997-2025 Urs Janssen <urs@tin.org>
+ * Copyright (c) 1997-2026 Urs Janssen <urs@tin.org>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -51,31 +51,33 @@
 /* active.c */
 extern char group_flag(char ch);
 extern int find_newnews_index(const char *cur_newnews_host);
-extern int read_news_active_file(t_bool check_any_unread);
+extern int read_news_active_file(void);
 extern t_bool match_group_list(const char *group, const char *group_list);
 extern t_bool parse_active_line(char *line, t_artnum *max, t_artnum *min, char *moderated);
 extern t_bool process_bogus(const char *name);
 extern t_bool need_reread_active_file(void);
 extern t_bool resync_active_file(void);
 extern void create_save_active_file(void);
-extern void load_newnews_info(char *info);
+extern void load_newnews_info(const char *info);
+extern void active_add(struct t_group *ptr, t_artnum count, t_artnum max, t_artnum min, const char *moderated);
 
 /* art.c */
 extern int find_artnum(t_artnum art);
 extern int global_get_multipart_info(int aindex, MultiPartInfo *setme);
 extern int global_get_multiparts(int aindex, MultiPartInfo **malloc_and_setme_info, t_bool tagging);
 extern t_bool global_look_for_multipart(int aindex, char start, char stop);
-extern t_bool index_group(struct t_group *group);
+extern t_bool index_group(struct t_group *group, t_bool flag);
 extern void do_update(t_bool catchup);
 extern void find_base(const struct t_group *group);
 extern void free_mailbox_list(struct t_mailbox *mb);
-extern void make_threads(struct t_group *group, t_bool rethread);
+extern void make_threads(const struct t_group *group, t_bool rethread);
 extern void set_article(struct t_article *art);
 extern void show_art_msg(const char *group);
-extern void sort_arts(unsigned /* int */ sort_art_type);
+extern void write_overview(struct t_group *group);
 
 /* attrib.c */
 extern int add_scope(const char *scope);
+extern t_bool getart_limit_set_from_scope(struct t_group *group);
 extern t_bool read_attributes_file(t_bool global_file);
 extern void assign_attributes_to_groups(void);
 extern void build_news_headers_array(struct t_attribute *scope, t_bool header_to_display);
@@ -90,20 +92,24 @@ extern void write_attributes_file(const
 extern char *convert_to_printable(char *buf, t_bool keep_tab);
 #ifdef CHARSET_CONVERSION
 #	ifdef USE_ICU_UCSDET
-	extern char *guess_charset(const char *sample, int32_t confidence);
+		extern char *guess_charset(const char *sample, int32_t confidence);
 #	endif /* USE_ICU_UCSDET */
+#	if defined(NNTP_ABLE) && defined(USE_GSASL)
+	extern int charset_name_to_num(const char *charset);
+#	endif /* NNTP_ABLE && USE_GSASL */
 #endif /* CHARSET_CONVERSION */
 extern t_bool charset_unsupported(const char *charset);
-extern t_bool is_art_tex_encoded(FILE *fp);
+extern t_bool charset_compare(const char *cs_a, const char *cs_b);
 extern void convert_iso2asc(char *iso, char **asc_buffer, size_t *max_line_len, int t);
-extern void convert_tex2iso(char *from, char *to);
+extern void convert_tex2iso(const char *from, char *to);
+extern void csguess_convert_str(char **line, const char *def_cs);
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 	extern wchar_t *wconvert_to_printable(wchar_t *wbuf, t_bool keep_tab);
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 extern const char *validate_charset(const char *charset);
 
 /* color.c */
-extern void draw_pager_line(const char *str, int flags, t_bool raw_data);
+extern void draw_pager_line(const char *str, unsigned int flags, t_bool raw_data);
 #ifdef HAVE_COLOR
 	extern void bcol(int color);
 	extern void fcol(int color);
@@ -116,23 +122,26 @@ extern void draw_pager_line(const char *
 extern char **ulBuildArgv(const char *cmd, int *new_argc);
 extern char *quote_space_to_dash(const char *str);
 extern const char *print_boolean(t_bool value);
-extern t_bool match_boolean(char *line, const char *pat, t_bool *dst);
+extern t_bool match_boolean(const char *line, const char *pat, t_bool *dst);
 extern t_bool match_integer(const char *line, const char *pat, int *dst, int maxval);
-extern t_bool match_list(char *line, constext *pat, constext *const *table, int *dst);
+extern t_bool match_list(const char *line, constext *pat, constext *const *table, int *dst);
 extern t_bool match_long(const char *line, const char *pat, long *dst);
-extern t_bool match_string(char *line, const char *pat, char *dst, size_t dstlen);
-extern t_bool match_string_ptr(char *line, const char *pat, char **dst);
+extern t_bool match_string(const char *line, const char *pat, char *dst, size_t dstlen);
+extern t_bool match_string_ptr(const char *line, const char *pat, char **dst);
 extern t_bool read_config_file(char *file, t_bool global_file);
 extern void quote_dash_to_space(char *str);
-extern void read_server_config(void);
+extern void read_server_config(unsigned int option_mask);
 extern void write_config_file(const char *file);
 
 /* cook.c */
-extern char *build_attach_line(const t_part *part, int depth, int max_len, int is_uue, const char *name, const char *charset);
+extern char *build_attach_line(const t_part *part, int depth, int max_len, enum section_type section, const char *name, const char *charset);
 extern const char *get_filename(t_param *ptr);
-extern t_bool cook_article(t_bool wrap_lines, t_openartinfo *artinfo, int hide_uue, t_bool show_all_headers);
+extern t_bool cook_article(t_bool wrap_lines, t_openartinfo *artinfo, int hide_inline_data, t_bool show_all_headers);
 extern t_bool expand_ctrl_chars(char **line, size_t *length, size_t lcook_width);
 
+/* crc32.c */
+extern uint32_t tin_crc32(uint32_t crc, const unsigned char *buf, size_t len);
+
 /* curses.c */
 extern OUTC_RETTYPE outchar(OUTC_ARGS);
 extern int InitScreen(void);
@@ -185,22 +194,19 @@ extern void word_highlight_string(int ro
 	extern void debug_print_filters(void);
 	extern void debug_print_header(struct t_article *s);
 	extern void debug_print_malloc(t_bool is_malloc, const char *xfile, int line, size_t size);
-#	ifdef NNTP_ABLE
-	extern const char *logtime(void);
-#	endif /* NNTP_ABLE */
 #endif /* DEBUG */
 
 /* envarg.c */
 extern void envargs(int *Pargc, char ***Pargv, const char *envstr);
 
 /* feed.c */
-extern int feed_articles(int function, int level, t_function type, struct t_group *group, int respnum);
+extern int feed_articles(int function, int level, t_function type, const struct t_group *group, int respnum);
 
 /* filter.c */
 extern t_bool filter_articles(struct t_group *group);
 extern t_bool filter_menu(t_function type, struct t_group *group, struct t_article *art);
 extern t_bool filter_on_path(struct t_group *group);
-extern t_bool quick_filter(t_function type, struct t_group *group, struct t_article *art);
+extern t_bool quick_filter(t_function type, const struct t_group *group, struct t_article *art);
 extern t_bool quick_filter_select_posted_art(const struct t_group *group, const char *subj, const char *a_message_id);
 extern t_bool read_filter_file(const char *file);
 extern void free_filter_array(struct t_filters *ptr);
@@ -264,8 +270,8 @@ extern const char *get_host_name(void);
 #endif /* !HAVE_HEAPSORT */
 
 /* inews.c */
-extern t_bool submit_news_file(char *name, struct t_group *group, char *a_message_id);
-extern void get_from_name(char *from_name, const struct t_group *thisgrp);
+extern t_bool submit_news_file(char *name, const struct t_group *group, char *a_message_id);
+extern void get_from_name(char *from_name, size_t len, const struct t_group *thisgrp);
 
 /* init.c */
 extern void init_selfinfo(void);
@@ -288,7 +294,6 @@ extern void setup_default_keys(void);
 #endif /* !NO_LOCALE */
 
 /* list.c */
-extern char *random_organization(char *in_org);
 extern int find_group_index(const char *group, t_bool ignore_case);
 extern struct t_group *group_add(const char *group);
 extern struct t_group *group_find(const char *group_name, t_bool ignore_case);
@@ -307,7 +312,7 @@ extern t_bool dot_unlock(const char *fil
 
 /* mail.c */
 extern t_bool art_edit(const struct t_group *group, const struct t_article *article);
-extern void find_art_max_min(const char *group_path, t_artnum *art_max, t_artnum *art_min);
+extern t_bool find_art_max_min(const char *group_path, t_artnum *art_max, t_artnum *art_min);
 extern void print_active_head(const char *active_file);
 extern void print_group_line(FILE *fp, const char *group_name, t_artnum art_max, t_artnum art_min, const char *base_dir);
 extern void read_descriptions(t_bool verb);
@@ -336,6 +341,7 @@ extern void free_all_arrays(void);
 extern void free_art_array(void);
 extern void free_save_array(void);
 extern void free_scope(int num);
+extern void free_scopes_list(struct t_group *group);
 extern void *my_malloc1(const char *file, int line, size_t size);
 extern void *my_calloc1(const char *file, int line, size_t nmemb, size_t size);
 extern void *my_realloc1(const char *file, int line, void *p, size_t size);
@@ -353,16 +359,18 @@ extern t_bool lookup_extension(char *ext
 /* misc.c */
 extern FILE *tin_fopen(const char *pathname, const char *mode);
 extern char *buffer_to_ascii(char *c);
-extern char *escape_shell_meta(const char *source, int quote_area);
+extern char *escape_shell_meta(const char *source, enum quote_enum quote_area);
 extern char *get_tmpfilename(const char *filename);
-extern char *idna_decode(char *in);
-extern char *quote_wild(char *str);
-extern char *quote_wild_whitespace(char *str);
+extern char *idna_decode(const char *in);
+extern char *quote_wild(const char *str);
+extern char *quote_wild_whitespace(const char *str);
+extern char *random_organization(char *in_org);
 extern char *strip_line(char *line);
 extern char *split_mailbox_list(char *from);
 extern const char *eat_re(char *s, t_bool eat_was);
 extern const char *get_val(const char *env, const char *def);
 extern const char *gnksa_strerror(int errcode);
+extern const char *logtime(void);
 extern int gnksa_check_from(const char *from);
 extern int gnksa_split_from(const char *from, char *address, char *realname, int *addrtype);
 extern int get_initials(struct t_article *art, char *s, int maxsize);
@@ -370,9 +378,10 @@ extern int gnksa_do_check_from(const cha
 extern int my_mkdir(const char *path, mode_t mode);
 extern int parse_from(const char *from, char *address, char *realname);
 extern int rndm(void);
+extern int sync_close(int fd);
 extern int strfmailer(const char *mail_prog, char *subject, char *to, const char *filename, char *dest, size_t maxsize, const char *format);
 extern int strfpath(const char *format, char *str, size_t maxsize, struct t_group *group, t_bool expand_all);
-extern int strfquote(const char *group, int respnum, char *s, size_t maxsize, char *format);
+extern int strfquote(const char *group, int respnum, char *s, size_t maxsize, const char *format);
 extern int tin_version_info(FILE *fp, int verb);
 extern int tin_gettime(struct t_tintime *tt);
 extern long file_mtime(const char *file);
@@ -408,9 +417,7 @@ extern void srndm(void);
 extern void strip_name(const char *from, char *address);
 extern _Noreturn void tin_done(int ret, const char *fmt, ...);
 extern void toggle_inverse_video(void);
-#if defined(CHARSET_CONVERSION) || (defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE))
-	extern char *utf8_valid(char *line);
-#endif /* CHARSET_CONVERSION || (MULTIBYTE_ABLE && !NO_LOCALE) */
+extern char *utf8_valid(char *line);
 #if defined(NO_LOCALE) || !defined(MULTIBYTE_ABLE)
 	extern int my_isprint(int c);
 #endif /* NO_LOCALE || !MULTIBYTE_ABLE */
@@ -469,6 +476,7 @@ extern void nntp_close(t_bool send_no_qu
 	extern int fgetc_server(FILE *stream);
 	extern int ungetc_server(int c, FILE *stream);
 	extern int nntp_conninfo(FILE *stream);
+	extern t_bool nntp_list_active_grp(const char *group, char *moderated);
 #	if defined(MAXARTNUM) && defined(USE_LONG_ARTICLE_NUMBERS)
 	extern void set_maxartnum(t_bool reconnect);
 #	endif /* MAXARTNUM && USE_LONG_ARTICLE_NUMBERS */
@@ -489,7 +497,7 @@ extern void tintls_exit(void);
 /* nrctbl.c */
 extern t_bool get_newsrcname(char *newsrc_name, size_t newsrc_name_len, const char *nntpserver_name);
 #ifdef NNTP_ABLE
-	extern void get_nntpserver(char *nntpserver_name, size_t nntpserver_name_len, char *nick_name);
+	extern void get_nntpserver(char *nntpserver_name, size_t nntpserver_name_len, const char *nick_name);
 #endif /* NNTP_ABLE */
 
 /* options_menu.c */
@@ -509,7 +517,7 @@ extern void draw_page(int part);
 extern void info_pager(FILE *info_fh, const char *title, t_bool wrap_at_ends);
 extern void log_article_info(t_openartinfo *artinfo);
 extern void resize_article(t_bool wrap_lines, t_openartinfo *artinfo);
-extern void update_hide_uue(void);
+extern void update_hide_inline_data(void);
 extern void toggle_raw(void);
 
 /* parsdate.y */
@@ -580,7 +588,7 @@ extern char *tin_fgets(FILE *fp, t_bool
 extern char *get_references(struct t_msgid *refptr);
 extern struct t_msgid *find_msgid(const char *msgid);
 extern t_bool valid_msgid(char *msgid);
-extern void build_references(const struct t_group *group);
+extern void build_references(void);
 extern void clear_art_ptrs(void);
 extern void collate_subjects(void);
 extern void free_msgids(void);
@@ -595,10 +603,11 @@ extern REGEX_SIZE *regex_get_ovector_poi
 extern void highlight_regexes(int row, struct regex_cache *regex, int color);
 extern void regex_cache_init(struct regex_cache *regex);
 extern void regex_cache_destroy(struct regex_cache *regex);
+extern char *regex_get_substring_by_name(struct regex_cache *re, const char *sname, char *subject);
 extern t_bool regex_use_utf8(void);
 
 /* rfc1524.c */
-extern t_mailcap *get_mailcap_entry(t_part *part, const char *path);
+extern t_mailcap *get_mailcap_entry(const t_part *part, const char *path);
 extern void free_mailcap(t_mailcap *tmailcap);
 
 /* rfc2045.c */
@@ -627,9 +636,10 @@ extern void unfold_header(char *line);
 extern char *rfc1522_decode(const char *s);
 extern char *rfc1522_encode(char *s, const char *charset, t_bool ismail);
 extern int mmdecode(const char *what, int encoding, int delimiter, char *where);
-extern void rfc15211522_encode(const char *filename, constext *mime_encoding, struct t_group *group, t_bool allow_8bit_header, t_bool ismail);
-extern void compose_mail_mime_forwarded(const char *filename, FILE *articlefp, t_bool include_text, struct t_group *group);
-extern void compose_mail_text_plain(const char *filename, struct t_group *group);
+extern int b642str(const char *in, char *out);
+extern void rfc15211522_encode(const char *filename, constext *mime_encoding, const struct t_group *group, t_bool allow_8bit_header, t_bool ismail);
+extern void compose_mail_mime_forwarded(const char *filename, FILE *articlefp, t_bool include_text, const struct t_group *group);
+extern void compose_mail_text_plain(const char *filename, const struct t_group *group);
 
 /* save.c */
 extern int check_start_save_any_news(int function, t_bool catchup, int num_cmd_line_groups);
@@ -665,7 +675,7 @@ extern enum option_enum search_config(t_
 extern int get_search_vectors(REGEX_SIZE *start, REGEX_SIZE *end);
 extern int search(t_function func, int current_art, t_bool repeat);
 extern int search_active(t_bool forward, t_bool repeat);
-extern int search_article(t_bool forward, t_bool repeat, int start_line, int lines, t_lineinfo *line, int reveal_ctrl_l_lines, FILE *fp);
+extern int search_article(t_bool forward, t_bool repeat, int start_line, int lines, const t_lineinfo *line, int reveal_ctrl_l_lines, FILE *fp);
 extern int search_body(const struct t_group *group, int current_art, t_bool repeat);
 extern int generic_search(t_bool forward, t_bool repeat, int current, int last, int level);
 extern void reset_srch_offsets(void);
@@ -715,6 +725,7 @@ extern size_t mystrcat(char **t, const c
 extern void my_strncpy(char *p, const char *q, size_t n);
 extern void parse_format_string(const char *fmtstr, struct t_fmt *fmt);
 extern void str_lwr(char *str);
+extern void str_upr(char *str);
 extern int my_tolower(int);
 extern int my_toupper(int);
 #if !defined(HAVE_STRCASESTR) || defined(DECL_STRCASESTR)
@@ -735,9 +746,6 @@ extern int my_toupper(int);
 #ifndef HAVE_STRNCASECMP
 	extern int strncasecmp(const char *p, const char *q, size_t n);
 #endif /* !HAVE_STRNCASECMP */
-#ifndef HAVE_ATOI
-	extern int atoi(const char *s);
-#endif /* !HAVE_ATOI */
 #ifndef HAVE_ATOL
 	extern long atol(const char *s);
 #endif /* !HAVE_ATOL */
@@ -757,9 +765,7 @@ extern int my_toupper(int);
 	extern char *wchar_t2char(const wchar_t *wstr);
 	extern wchar_t *abbr_wcsgroupname(const wchar_t *grpname, int len);
 	extern wchar_t *char2wchar_t(const char *str);
-	extern wchar_t *my_wcsdup(const wchar_t *wstr);
 	extern wchar_t *wcspart(const wchar_t *wstr, size_t columns, t_bool pad);
-	extern wchar_t *wexpand_tab(const wchar_t *wstr, size_t tab_width);
 	extern wchar_t *wstrunc(const wchar_t *wmessage, size_t len);
 #else
 	extern char *abbr_groupname(const char *grpname, size_t len);
